<template>
  <v-dialog v-model="dialogUnit" @click:outside="close" max-width="50%">
    <v-card class="pa-8">
      <v-card-title class="justify-center text-h5 d-flex font-weight-bold">
        {{ dialogTitle }}
      </v-card-title>
      <v-divider class="mt-2 mb-6"></v-divider>

      <AdminUnitsUnitForm :unit="unit" />

      <v-card-actions class="justify-center d-flex">
        <v-btn variant="outlined" rounded size="large" data-cy="UnitFormCancelBtn" class="text-uppercase" @click="close()">
          Annuler
        </v-btn>
        <v-btn variant="outlined" rounded size="large" data-cy="UnitFormOkBtn" class="text-uppercase inverted" :disabled="!meta.valid"
          :loading="loading" @click="confirm()">
          Valider
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { Unit } from "~/dto/unit.dto";

const dialogUnit = defineModel<boolean>();

const props = defineProps<{ unit: Unit }>();

const emit = defineEmits(['close', 'confirm']);

const { validate, meta } = useForm({
  initialValues: props.unit
})

const dialogTitle = ref(props.unit.id ? `Édition d'une unité` : `Création d'une unité`);
const loading = ref(false);

const close = () => {
  emit('close');
};

const confirm = async () => {
  const { valid } = await validate();
  if (!valid) {
    return;
  }
  emit('confirm');
  loading.value = true;
};
</script>
